import path from 'path';
import { startPreviewServer } from './previewServer-BHxxHO8G.js';
import 'chalk';
import 'vite';
import './runtime-B_bGx0NP.js';
import '@vitejs/plugin-react';
import 'debug';
import 'read-pkg-up';
import '@sanity/cli';
import 'resolve-from';
import 'connect-history-api-fallback';
import 'fs';
import 'fs/promises';
import { gracefulServerDeath, getSharedServerConfig } from './servers-BEv-khCo.js';
async function startSanityPreviewServer(args, context) {
  const flags = args.extOptions;
  const {
    workDir,
    cliConfig
  } = context;
  const defaultRootDir = path.resolve(path.join(workDir, "dist"));
  const rootDir = path.resolve(args.argsWithoutOptions[0] || defaultRootDir);
  const config = getPreviewServerConfig({
    flags,
    workDir,
    cliConfig,
    rootDir
  });
  try {
    await startPreviewServer(config);
  } catch (err) {
    gracefulServerDeath("preview", config.httpHost, config.httpPort, err);
  }
}
function getPreviewServerConfig(_ref) {
  let {
    flags,
    workDir,
    cliConfig,
    rootDir
  } = _ref;
  const baseConfig = getSharedServerConfig({
    flags,
    workDir,
    cliConfig
  });
  return {
    ...baseConfig,
    root: rootDir
  };
}
export { startSanityPreviewServer as default };
//# sourceMappingURL=previewAction-CzsIbY6e.js.map
