'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var cli = require('@sanity/cli');
const envPrefix = "SANITY_STUDIO_";
function getStudioEnvironmentVariables() {
  let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  const {
    prefix = "",
    envFile = false,
    jsonEncode = false
  } = options;
  const fullEnv = envFile ? {
    ...process.env,
    ...cli.loadEnv(envFile.mode, envFile.envDir || process.cwd(), [envPrefix])
  } : process.env;
  const studioEnv = {};
  for (const key in fullEnv) {
    if (key.startsWith(envPrefix)) {
      studioEnv["".concat(prefix).concat(key)] = jsonEncode ? JSON.stringify(fullEnv[key] || "") : fullEnv[key] || "";
    }
  }
  return studioEnv;
}
Object.defineProperty(exports, "createCliConfig", {
  enumerable: true,
  get: function () {
    return cli.createCliConfig;
  }
});
Object.defineProperty(exports, "defineCliConfig", {
  enumerable: true,
  get: function () {
    return cli.defineCliConfig;
  }
});
Object.defineProperty(exports, "getCliClient", {
  enumerable: true,
  get: function () {
    return cli.getCliClient;
  }
});
exports.getStudioEnvironmentVariables = getStudioEnvironmentVariables;
//# sourceMappingURL=cli.js.map
